#!/usr/bin/env python

import sys, time
import qt

# Python Cookbook, P. 16
def timeo(n, fun, *args):
    def void(): pass
    start = time.clock()
    for i in range(n): void()
    stend = time.clock()
    overhead = stend - start
    start = time.clock()
    for i in range(n): fun(*args)
    stend = time.clock()
    thetime = stend - start
    return fun.__name__, thetime - overhead

def intstr(v):
    return int(str(v))

def intlatin1(v):
    return int(v.latin1())

def toint(v):
    return v.toInt()[0]

def tolong(v):
    return v.toLong()[0]

def tolonglong(v):
    return v.toLongLong()[0]

def runtest(a):
    print "value:", a
    v = qt.QString(a)
    for f in intstr, intlatin1, toint, tolong, tolonglong:
        try:
            r = f(v)
        except:
            print f.__name__, "not supported!"
            continue
        if str(r) != a:
            print f.__name__, "failed:", r
            continue
        print "%s: %.2f" % timeo(100000, f, v)
    print

if __name__ == '__main__':
    if len(sys.argv) > 1:
        for a in sys.argv[1:]:
            runtest(a)
    else:
        runtest('12345678')


